/** @component input */
import { OnChanges, SimpleChanges, EventEmitter } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
export declare class InputComponent implements ControlValueAccessor, OnChanges {
    control: NgControl;
    value: any;
    readonly hasRequiredError: boolean;
    readonly errorValid: any;
    constructor(control: NgControl);
    readonly wrapperClasses: {
        [x: string]: any;
        [x: number]: any;
        'read-only': boolean;
        disabled: boolean;
        error: boolean;
    };
    readonly inputClasses: {
        [x: string]: any;
        'read-only': boolean;
        disabled: boolean;
        dirty: any;
    };
    private innerValue;
    private onTouchedCallback;
    private onChangeCallback;
    /** @prop Optional css class string | ''  */
    class: string;
    /** @prop optional button to clear input text */
    clear: boolean;
    /** @prop Sets the disabled attribute of the Input | false */
    disabled: boolean;
    /** @prop Unique HTML ID used for tying label to HTML input for automated testing */
    htmlId: string;
    /** @prop Array of objects with error type and error message */
    errorArr: any[];
    /** @prop Input css class name string */
    inputClass: string;
    /** @prop Help Text to appear under the input | '' */
    inputHelpText: string;
    /** @prop Overall input group size | '' */
    inputSize: string;
    /** @prop Input label text | '' */
    label: string;
    /** @prop Placeholder text to display when Input is empty | '' */
    placeholder: string;
    /** @prop Determines if Input can be edited | false */
    readOnly: boolean;
    /** @prop Secondary Input label | ''  */
    secondaryLabel: string;
    /** @prop Input color theme | '' */
    theme: string;
    /** @prop Input type | 'text' */
    type: string;
    /** @prop Sets the attribute name to the input element | '' */
    name: string;
    /** @prop Optional error messages object with angular validators | {} */
    errorObj: object;
    /** @prop function when clicked outside of input */
    handleBlur: EventEmitter<any>;
    /** @prop function when input is focused */
    handleFocus: EventEmitter<any>;
    /** @prop function when key down on input */
    handleKeyDown: EventEmitter<any>;
    /** @prop function when mouse down on input */
    handleMouseDown: EventEmitter<any>;
    errorType: any;
    errors: any;
    onBlur(event: any): void;
    onFocus(event: any): void;
    onKeyDown(event: any): void;
    onMouseDown(event: any): void;
    writeValue(value: any): void;
    setDisabledState(isDisabled: boolean): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    private determineErrorType;
    private filterErrorsByType;
    ngOnChanges(changes: SimpleChanges): void;
    handleClear(): void;
}
